﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Dim pdd As jUUID	'device id
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	Dim device_id As String = Get_DeviceID
	Log(device_id)
	Main.fx.Clipboard.SetString(device_id)	'placed to clipboard
	xui.MsgboxAsync("placed to clipboard:" & CRLF & device_id, "Windows device_id: " & device_id.Length)
End Sub

Sub Get_DeviceID As String
	Dim sb As StringBuilder
	sb.Initialize
	
	Dim sr As String = pdd.Get_MotherboardSN
	If sr <> Null And Not(sr.Contains("O.E.M")) Then sb.Append(sr)
	sr = pdd.Get_CPUID
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_MachineID
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_HddID1
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_HddID2
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_MacId
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_BiosVersion
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_CPUName
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_GpuID
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_MotherboardSN2
	If sr <> Null Then sb.Append(sr).Append("_")
	sr = pdd.Get_HWID1
	If sr <> Null Then sb.Append(sr)
	
	sr = sb.ToString
	
	If sr.As(String).Trim = "" Then
		sr = sr & GetEnvironmentVariable("computername","") & GetSystemProperty("user.name","")
	End If
	sr = sr.Replace(" ", "").Replace("\", "").Replace("/", "").Replace(":", "")
'	If sr.Length > 48 Then
'		sr = sr.SubString2(0, 48)
'	End If
	
	Return sr.ToLowerCase
End Sub